#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <set>
#include <map>
#include <deque>
#include <algorithm>
#include <queue>
#include <ctime>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <random>
#include <chrono>
#include <list>
using namespace std;

//#define int ll

typedef long long ll;
typedef long double ld;
typedef pair <int , int> pii;
typedef pair <ll , ll> pll;


#define ff first
#define ss second
#define mp make_pair
#define pf push_front
#define pb push_back
#define IO ios_base::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);
#define print(x) { for (auto xxxxxxxxx : (x)) cout << xxxxxxxxx << ' '; cout << '\n'; }
#define printp(x) { for (auto xxxxxxxxx : (x)) cout << "{" << xxxxxxxxx.ff << ", " << xxxxxxxxx.ss << "} "; cout << '\n'; }
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const ll mod=1e9+7;
const ll inf=2e18+5;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll random(ll l, ll r){ return uniform_int_distribution<ll>(l, r)(rng);}

const ld EPS = 1E-9;
struct pt {
    ld x, y;
    bool operator< (const pt & p) const {
        return x < p.x-EPS || abs(x-p.x) < EPS && y < p.y - EPS;
    }
};
struct line {
    ld a, b, c;
    line() {}
    line (pt p, pt q) {
        a = p.y - q.y;
        b = q.x - p.x;
        c = - a * p.x - b * p.y;
        norm();
    }
    void norm() {
        ld z = sqrt (a*a + b*b);
        if (abs(z) > EPS)
            a /= z, b /= z, c /= z;
    }
    ld dist (pt p) const {
        return a * p.x + b * p.y + c;
    }
};

#define det(a,b,c,d) (a*d-b*c)
inline bool betw (ld l, ld r, ld x) {
    return min(l,r) <= x + EPS && x <= max(l,r) + EPS;
}
inline bool intersect_1d (ld a, ld b, ld c, ld d) {
    if (a > b) swap (a, b);
    if (c > d) swap (c, d);
    return max (a, c) <= min (b, d) + EPS;
}
bool intersect (pt a, pt b, pt c, pt d , pt &left , pt &right) {
    if (! intersect_1d (a.x, b.x, c.x, d.x) || ! intersect_1d (a.y, b.y, c.y, d.y))
        return false;
    line m (a, b);
    line n (c, d);
    ld zn = det (m.a, m.b, n.a, n.b);
    if (abs (zn) < EPS) {
        if (abs (m.dist (c)) > EPS || abs (n.dist (a)) > EPS)
            return false;
        if (b < a) swap (a, b);
        if (d < c) swap (c, d);
        left = max (a, c);
        right = min (b, d);
        return true;
    }
    else {
        left.x = right.x = - det (m.c, m.b, n.c, n.b) / zn;
        left.y = right.y = - det (m.a, m.c, n.a, n.c) / zn;
        return betw (a.x, b.x, left.x)
               && betw (a.y, b.y, left.y)
               && betw (c.x, d.x, left.x)
               && betw (c.y, d.y, left.y);
    }
}

int n;
vector <pt> a;

int check() {
    set <pii> s;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            s.insert({i , j});
        }
    }
    int cnt = 0;
    while (!s.empty()) {
        pii cur = *s.begin();
        s.erase(s.begin());
        vector <pii> del;
        for (auto x : s) {
            pt t1 = {0 , 0} , t2 = {1 , 1};
            if (intersect(a[cur.first] , a[cur.second] , a[x.first] , a[x.second] , t1 ,t2)) {
                if (abs(t1.x - t2.x) < EPS && abs(t1.y - t2.y) < EPS) {
                    continue;
                }
                del.push_back(x);
            }
        }
        for (auto x : del) {
            s.erase(x);
        }
        cnt++;
    }
    cout << cnt << '\n';
    return cnt%2;
}
int intf = 1e9;
pii ask(pii cur = {intf , intf}) {
    if (cur.first == intf) {
        cin >> cur.first >> cur.second;
        cur.first-- , cur.second--;
        return cur;
    } else {
        cur.first++ , cur.second++;
        cout << cur.first << ' ' << cur.second << endl;
    }
}

void solve(){
    cin >> n;
    a.resize(n);
    for (auto &x : a) {
        cin >> x.x >> x.y;
    }

    int type = check();
    if (type == 0)
        type = 2;

    //cout << type << endl;
    set <pii> s;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            s.insert({i , j});
        }
    }
    type %= 2;

    while (true) {
        pii cur;
        if (type == 1) {
            cur = *s.begin();
            cout << cur.first + 1 << ' ' << cur.second + 1 << endl;
        } else {
            cin >> cur.first >> cur.second;
            cur.first-- , cur.second--;
        }
        if (cur.first < 0) {
            return;
        }
        type = (type + 1) % 2;

        if (s.empty()) {
            cout << "-1 -1\n";
            return;
        }
        s.erase(cur);
        vector <pii> del;
        for (auto x : s) {
            pt t1 = {0 , 0} , t2 = {1 , 1};
            if (intersect(a[cur.first] , a[cur.second] , a[x.first] , a[x.second] , t1 ,t2)) {
                //cout << t1.x << ' ' << t1.y << ' ' << t2.x << ' ' << t2.y << '\n';
                if (abs(t1.x - t2.x) < EPS && abs(t1.y - t2.y) < EPS) {
                    continue;
                }
                del.push_back(x);
            }
        }
        for (auto x : del) {
            s.erase(x);
        }
    }
}
/*
3
0 0
10 0
0 10

4
0 0
10 0
5 7
5 3

 */
signed main() {
    //IO
    //freopen(".in" , "r" , stdin);freopen(".out" , "w" , stdout);
    int t=1;
    //cin >> t;
    while(t--) solve();
}