#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <cmath>
#include <bitset>
#include <queue>
#include <map>
#include <random>
#include <queue>

using namespace std;

#define ll long long
#define endl '\n'
#define BE(v) v.begin(), v.end()
#define fi first
#define se second
#define pb emplace_back
#define ld long double

#define ALG
//#define MINT
//#define GEOM

#ifdef ALG
namespace alg_space
{
	template<class T>
	T sqr(T a)
	{
		return a * a;
	}

	template<class T>
	T gcd(T a, T b)
	{
		while (b != 0)
		{
			a %= b;
			swap(a, b);
		}
		return a;
	}
}

using namespace alg_space;
#endif

#ifdef MINT
namespace mint_space
{
#define FACT

#ifdef FACT
	const ll  MINT_N = 2e5;
#endif
	const ll  MINT_MOD = 1e9 + 7;

	struct mint
	{
		long long a;
		mint(ll  b) : a(b) {}
		mint(long long b) : a(b) {}
		mint() : a(0) {}
	};

	istream& operator>>(istream& cin, mint a)
	{
		return cin >> a.a;
	}

	ostream& operator<<(ostream& cout, const mint& a)
	{
		return cout << a.a;
	}

	mint operator+=(mint& a, mint b)
	{
		a.a += b.a;
		if (a.a > MINT_MOD)
		{
			a.a -= MINT_MOD;
		}
		return a;
	}

	mint operator+(mint a, mint b)
	{
		return a += b;
	}

	mint operator-=(mint& a, mint b)
	{
		a.a -= b.a;
		if (a.a < 0)
		{
			a.a += MINT_MOD;
		}
		return a;
	}

	mint operator-(mint a, mint b)
	{
		return a -= b;
	}

	mint operator*=(mint& a, mint b)
	{
		a.a *= b.a;
		a.a %= MINT_MOD;
		return a;
	}

	mint operator*(mint a, mint b)
	{
		return a *= b;
	}

	mint operator^(mint a, ll  b)
	{
		mint ans = 1;
		mint now = a;
		ll  i = 1;
		while (true)
		{
			if (i & b)
			{
				ans *= now;
			}
			if (i == (1 << 30))
			{
				break;
			}
			i <<= 1;
			now *= now;
		}
		return ans;
	}

	mint operator/=(mint& a, mint b)
	{
		a *= (b ^ (MINT_MOD - 2));
		return a;
	}

	mint operator/(mint a, mint b)
	{
		return a /= b;
	}

#ifdef FACT
	mint f[MINT_N];
	mint f1[MINT_N];

	void f_count(ll  n)
	{
		f[0] = 1;
		f1[0] = 1;
		for (ll  i = 1; i < n; i++)
		{
			f[i] = f[i - 1] * i;
			f1[i] = 1 / f[i];
		}
	}

	mint get_c(ll  n, ll  k)
	{
		return f[n] * f1[k] * f1[n - k];
	}

	mint get_a(ll  n, ll  k)
	{
		return f[n] * f1[n - k];
	}
#endif
}

using namespace mint_space;
#endif


const ll  N = 2e5 + 1337;

ll  t;
ll  n;
ll  good[N];
ll  bad[N];

int  main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> t;

	while (t-- > 0)
	{
		ll  n;
		cin >> n;
		ll  sum = 0;
		for (ll  i = 0; i < n; i++)
		{
			cin >> bad[i];
			sum += bad[i];
		}

		ll  cnt = 0;
		ll  id = 0;
		ll  Max = 0;
		ll  sumG = 0;
		for (ll  i = 0; i < n; i++)
		{
			cin >> good[i];
			if(good[i] > sum - bad[i])
			{
				id = i;
				cnt++;
			}
			if (good[i] > Max)
			{
				sumG += Max;
				Max = good[i];
			}
			else
			{
				sumG += good[i];
			}
		}

		if (cnt)
		{
			sumG += Max;
			sumG -= good[id];
		}

		if (cnt < 2 && sumG <= sum)
		{
			cout << "YES" << endl;
		}
		else
		{
			cout << "NO" << endl;
		}
	}
}