import java.util.*;
import java.io.*;

public class Main {
    static Scanner sc = new Scanner(System.in);
    static PrintWriter pw = new PrintWriter(System.out);

    static long[] fact = new long[17];
    static long ans = 0, sum = 0;
    static int n, k;
    static TreeMap<Integer, Integer> cnt = new TreeMap<>();

    public static void main(String[] args) throws IOException {
        n = sc.nextInt();
        k = sc.nextInt();
        setFact();
        rec(1);
        pw.print(ans);
        pw.close();
    }

    static void setFact() {
        fact[0] = 1;
        for (int i = 1; i < 17; i++)
            fact[i] = fact[i - 1] * i;
    }

    static void rec(int num) {
        if (num == 16) {
            if (sum != n)
                return;
            long res = 1;
            for (int count : cnt.values())
                res *= fact[count + k - 1] / (fact[k - 1] * fact[count]);
            ans += res;
            return;
        }
        for (int i = 0; i <= n - sum; i += num) {
            sum += i;
            cnt.put(num, i / num);
            rec(num + 1);
            cnt.remove(num);
            sum -= i;
        }
    }
}

class Scanner {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");

    public Scanner(InputStream inputStream) {
        br = new BufferedReader(new InputStreamReader(inputStream));
    }

    public Scanner(String file) throws FileNotFoundException {
        br = new BufferedReader(new FileReader(file));
    }

    public boolean hasNext() throws IOException {
        if (st.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            st = new StringTokenizer(s);
            if (st.hasMoreTokens()) return true;
        }
        return false;
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public String next() throws IOException {
        hasNext();
        return st.nextToken();
    }
}
