#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

template <class T = int>
T next() { T x; cin >> x; return x; }

map<pair<int, int>, int> count_color;

int count_colors(int n, int k)
{
    if (n == 0 && k == 0)
        return 1;

    if (k == 0)
        return 0;

    if (count_color.count(make_pair(n, k)))
        return count_color[make_pair(n, k)];

    int ans = 0;
    for (int i = 0; i <= n; i++)
        ans += count_colors(n - i, k - 1);

    return count_color[make_pair(n, k)] = ans;
}

int k_save;
vector<int> perm;

ll count_all(int n, int last = -1)
{
    if (last == -1)
        last = n;

    if (n == 0)
    {
        ll all_ans = 1;
        vector<int> mask(16);

        for (int i = 0; i < perm.size(); i++)
            mask[perm[i]]++;

        for (int i = 0; i < mask.size(); i++)
            if (mask[i])
                all_ans *= count_colors(mask[i], k_save);
        
        return all_ans;
    }

    ll ans = 0;
    for (int i = 1; i <= min(last, n); i++)
    {
        perm.push_back(i);
        ans += count_all(n - i, i);
        perm.pop_back();
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0); cin.tie(0);

    int n, k;
    cin >> n >> k;
    k_save = k;

    cout << count_all(n) << '\n';

    return 0;
}