#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

template <class T = int>
T next() { T x; cin >> x; return x; }

int _size = 1;
vector<int> tree;
#define ls(v) (v << 1)
#define rs(v) ((v << 1) + 1)

void update(int v)
{
    if (v == 0) return;
    tree[v] = tree[ls(v)] + tree[rs(v)];
    update(v >> 1);
}

int get_ans(int l, int r)
{
    int ans = 0;
    l += _size, r += _size;

    while (l <= r)
    {
        if (l & 1) ans += tree[l++];
        if (~r & 1) ans += tree[r--];
        l >>= 1, r >>= 1;
    }

    return ans;
}

int solve_slow(int n, int m, int s, vector<int> arr)
{
    vector<int> mask(n);

    for (int v : arr)
        mask[v - 1] = 1;

    int count = 0;
    for (int i = 0; i < n; i++)
    {
        int ans = 0;
        for (int k = 0; k < m && i + k < n; k++)
            ans += mask[i + k];

        if (ans + s >= m)
            count++;
    }

    return count;
}

int solve_fast(int n, int m, int s, vector<int> arr)
{
    arr.push_back(0);
    sort(arr.begin(), arr.end());
    arr.erase(unique(arr.begin(), arr.end()), arr.end());

    ll ans = 0;
    for (int i = 1; i < arr.size(); i++)
    {
        int d1 = arr[i] - arr[i - 1];

        //int l = 1, r = arr.size() + 1;
        //while (r - l > 1)
        //{
        //    int mid = (r - l >> 1) + l;

        //    if (arr[mid] <= arr[i] + m - 1)
        //        l = mid;
        //    else
        //        r = mid;
        //}

        //// find answer in l 
        //if (l - i + 1 + s < m)
        //    continue;

        int r = i + m - s - 1;
        
        if (r > arr.size() - 1)
            continue;

        ans += min(d1, max(0, arr[i] - arr[r] + m));
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0); cin.tie(0);

    /*random_device random;

    while (true)
    {
        int n = (random() % 100) + 1;
        int s = (random() % 10) + 1;
        int m = s + (random() % 10) + 1;
        vector<int> arr(m);

        for (int& v : arr)
            v = (random() % n) + 1;

        if (solve_fast(n, m, s, arr) != solve_slow(n, m, s, arr))
            cout << "NOT OK!\n";
        else
            cout << "OK!\n";
    }*/

    int n, m, s;
    cin >> n >> m >> s;
    vector<int> arr(m);

    for (int& v : arr)
        cin >> v;

    cout << solve_fast(n, m, s, arr) << '\n';

    return 0;
}