#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <random>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

template <class T = int>
T next() { T x; cin >> x; return x; }

int solve_slow(int n, int m, int s, vector<int> arr)
{
    vector<int> mask(n);

    for (int v : arr)
        mask[v - 1] = 1;

    int count = 0;
    for (int i = 0; i < n; i++)
    {
        int need_s = 0, els = 0;
        for (int k = 0; k < m && i + k < n; k++)
        {
            els++;
            need_s += mask[i + k] == 0;
        }

        if (els == m && need_s <= s)
            count++;
    }

    return count;
}

ll solve_fast(int n, int m, int s, vector<int> arr)
{
    arr.push_back(0);
    sort(arr.begin(), arr.end());
    arr.erase(unique(arr.begin(), arr.end()), arr.end());

    ll ans = 0;
    for (int i = 1; i < arr.size(); i++)
    {
        int d1 = arr[i] - arr[i - 1];

        //int l = 1, r = arr.size() + 1;
        //while (r - l > 1)
        //{
        //    int mid = (r - l >> 1) + l;

        //    if (arr[mid] <= arr[i] + m - 1)
        //        l = mid;
        //    else
        //        r = mid;
        //}

        //// find answer in l 
        //if (l - i + 1 + s < m)
        //    continue;

        if (arr[i] + m - 1 >= n)
        {
            set<int> mask(arr.begin(), arr.end());

            int x = n - m + 1;

            if (x <= arr[i - 1])
                break;

            int need_s = 0;

            for (int j = x; j <= n; j++)
                need_s += mask.count(j) == 0;

            while (x > arr[i - 1] && x + m - 1 >= arr[i])
            {
                if (need_s <= s)
                    ans++;

                need_s += mask.count(x - 1) == 0;
                need_s -= mask.count(x + m - 1) == 0;

                x--;
            }

            break;
        }

        int r = i + m - s - 1;
        
        if (r > arr.size() - 1)
            continue;

        ans += min(d1, max(0, arr[i] - arr[r] + m));
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0); cin.tie(0);

    /*random_device random;

    while (true)
    {
        int n = (random() % 1000) + 1;
        int s = (random() % 1000) + 1;
        int m = s + (random() % 1000) + 1;
        vector<int> arr(m);

        for (int& v : arr)
            v = (random() % n) + 1;

        if (solve_fast(n, m, s, arr) != solve_slow(n, m, s, arr))
            cout << "NOT OK!\n";
        else
            cout << "OK!\n";
    }*/

    int n, m, s;
    cin >> n >> m >> s;
    vector<int> arr(m);

    for (int& v : arr)
        cin >> v;

    cout << solve_fast(n, m, s, arr) << '\n';

    return 0;
}