/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,avx2,tune=native")
*/

#include <iostream>
#include <cstdio>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <string>
#include <utility>
#include <set>
#include <stack>
#include <deque>
#include <ctime>
#include <random>
#include <cassert>
#include <cmath>
#include <climits>
#include <queue>
#include <cstring>
#include <bitset>
#include <iomanip>
#include <chrono>

#ifdef LOCAL
	#define dbg(x) cerr << #x << " : " << x << endl;
#else
	#define dbg(x)
#endif


#define int long long
#define pb push_back
#define ppb pop_back()
#define mp make_pair
#define lb lower_bound
#define ub upper_bound
#define all(x) x.begin(), x.end()
#define sz(a) (int)a.size()
#define siz(a) (int)a.size()
#define fr first
#define se second
#define cinv(v) for (auto& x: v) cin >> x
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, v) for (auto &x : v)

template <typename T1, typename T2> inline bool chkmin(T1 &x, const T2 &y) {if (y < x) {x = y; return 1;} return 0;}
template <typename T1, typename T2> inline bool chkmax(T1 &x, const T2 &y) {if (x < y) {x = y; return 1;} return 0;}

#define mine chkmin
#define maxe chkmax

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef char ch;
typedef string str;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef vector<ch> vch;
typedef vector<str> vs;

const int MOD = (int)1e9 + 7;
const int INF = (int)1e9 + 50;
const long long BIG = (long long)2e18 + 50;
const int MX = 200010;
const double EPS = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());

template<typename T> ostream& operator<< (ostream &out, const vector<T> &b) {
	for (auto k : b) out << k << ' ';
	return out;
}

template<typename T> istream& operator>> (istream &in, vector<T> &b) {
	for (auto& k : b) in >> k;
	return in;
}

istream& operator>> (istream& in, pii& b) {
	in >> b.first >> b.second;
	return in;
}

ostream& operator<< (ostream& out, const pii& b) {
	out << "{" << b.first << ", " << b.second << "}";
	return out;
}

struct pt {
    int x;
    int y;
    pt (int _x = 0, int _y = 0) {
        x = _x;
        y = _y;
    }
    pt (pt a, pt b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }
    pt perp() {
        return pt(-y, x);
    }
    ll len2() {
        return x * x + y * y;
    }
    double len() {
        return sqrt(len2());
    }
    pt operator + (pt p) {
        return pt(x + p.x, y + p.y);
    }
    ll operator * (pt p) {
        return x * p.y - y * p.x;
    }
    ll operator ^ (pt p) {
        return x * p.x + y * p.y;
    }
    bool operator < (const pt & p) const {
        return mp(x, y) < mp(p.x, p.y);
    }
};

istream& operator >> (istream & cin, pt & p) {
    cin >> p.x >> p.y;
    return cin;
} 

ostream& operator << (ostream & cout, pt & p) {
    cout << p.x << ' ' << p.y;
    return cout;
}

#define vec pt


ll dist2(pt a, pt b) {
    return pt(a, b).len2();
}

double dist(pt a, pt b) {
    return sqrt(dist2(a, b));
}


double ang(pt a, pt b) {
    return atan2(a * b, a ^ b);
}

double segdist(pt a, pt b, pt c) {
    double res = min(dist(a, c), dist(b, c));
    vec ab(a, b);
    vec ac(a, c);
    vec ba(b, a);
    vec bc(b, c);   
    if ((ab ^ ac) > 0 && (ba ^ bc) > 0) 
        return abs(ac * bc) / dist(a, b);
    return res;
}

bool cmp(pt a, pt b) {
    if (a * b == 0)
        return a.len2() < b.len2();
    return a * b > 0;
}

vector<pt> build_hull(vector<pt> pts) {
    int n = pts.size();
    pt p = pts[0];
    fi(0, n)
        mine(p, pts[i]);
    fi(0, n)
        pts[i] = pt(p, pts[i]);
    sort(all(pts), cmp);
    vector<pt> hull = {pts[0]};
    fi(1, n) {
        while (hull.size() > 1) {
            if (pt(hull[siz(hull) - 2], hull.back()) * pt(hull.back(), pts[i]) < EPS) 
                hull.ppb;
            else
                break;
        }
        hull.pb(pts[i]);
    }
    fx(x, hull) {
        x = x + p;
    }
    return hull;
}

struct line {
    int a;
    int b;
    int c;
    line (int _a = 0, int _b = 0, int _c = 0) {
        a = _a;
        b = _b;
        c = _c;
    }
    line(pt p1, pt p2) {
        a = p1.y - p2.y;
        b = p2.x - p1.x;
        c = -a * p1.x - b * p1.y;
    }
    double dist(pt p) {
        return abs(p.x * a + p.y * b + c) / sqrt(a * a + b * b);
    }
};

struct cir {
    pt C;
    double r;
    cir (pt _C, double _r) {
        C = _C;
        r = _r;
    }
};

const int MAXN = 310;


int sgn(int x) {
	if (x == 0) return 0;
	if (x < 0) return -1;
	return 1;
}

bool intersect(pt a, pt b, pt c, pt d) {
	vec ab(a, b);
	vec ac(a, c);
	vec ad(a, d);
	vec cd(c, d);
	vec ca(c, a);
	vec cb(c, b);
	// one line ? ))
	int p1 = sgn(ab * ac);
	int p2 = sgn(ab * ad);
	int p3 = sgn(cd * ca);
	int p4 = sgn(cd * cb);
	assert(p1 && p2 && p3 && p4);
	return p1 * p2 < 0 && p3 * p4 < 0;
}


pt a[MAXN];
vector<pii> pos;

void add_turn(int p1, int p2) {
	vector<pii> npos;
	for (auto[c, d] : pos) {
		if (c == p1 && d == p2) continue;
		if (d == p1 && c == p2) continue;
		if (c == p1 || c == p2 || d == p1 || d == p2) {
			npos.pb({c, d});
			continue;
		}
		if (intersect(a[p1], a[p2], a[c], a[d])) continue;
		npos.pb({c, d});
	}
	pos = npos;
}

void go(int p1, int p2) {
	cout << p1 + 1 << " " << p2 + 1 << endl;
	add_turn(p1, p2);
	cin >> p1 >> p2;
	if (p1 == 0 && p2 == 0) {
		exit(0);
	}
	p1--, p2--;
	add_turn(p1, p2);
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<pt> A(n);
	for (int i = 0; i < n; i++) {
		A[i] = a[i];
	}
	vector<pt> b = build_hull(A);
	int k = b.size();
	int turns = k + k - 3 + (n - k) * 3;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			pos.pb({i, j});
		}
	}
	if (turns % 2 == 0) {
		cout << 2 << endl;
		int p1, p2;
		cin >> p1 >> p2;
		p1--, p2--;
		add_turn(p1, p2);
	} else {
		cout << 1 << endl;
	}
	while (1) {
		assert(!pos.empty());
		auto[p1, p2] = pos[0];
		go(p1, p2);
	}
}
