#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cmath>
#include <random>
#include <unordered_map>

#define int long long
using namespace std;

struct point {
	int x, y;
};

struct vec {
	int x, y;
	int operator*(const vec &b) {
		return x * b.x + y * b.y;
	}
	int operator^(const vec& b) {
		return x * b.y - y * b.x;
	}
	vec(point a, point b) {
		x = b.x - a.x;
		y = b.y - a.y;
	}
};

bool check(point a, point b, point c) {
	return (c.x - a.x) * (b.y - a.y) - (c.y - a.y) * (b.x - a.x) <= 0;
}

bool inters(point a, point b, point c, point d) {
	vec v1(a, b);
	vec v2(a, c);
	vec v3(a, d);
	vec v4(c, d);
	vec v5(c, b);
	vec v6(c, a);
	return (v1 ^ v2) * (v1 ^ v3) < 0 && (v4 ^ v5) * (v4 ^ v6) < 0;
}

bool cmp(point a, point b) {
	return (a.x < b.x) || (a.x == b.x && a.y < b.y);
}

signed main() {
	int n;
	cin >> n;
	vector <point> p(n);
	for (int i = 0; i < n; i++) {
		cin >> p[i].x >> p[i].y;
	}
	sort(p.begin(), p.end(), cmp);
	int tre = 0;
	vector <vector <int>> pare2(n, vector <int>(n, 1));
	while (true) {
		int a = -1, b = -1;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i == j) continue;
				if (pare2[i][j] == 1) {
					a = i; b = j;
				}
			}
		}
		if (a == -1) break;
		pare2[a][b] = 0;
		pare2[b][a] = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i == j || i == a || i == b || j == a || j == b) continue;
				if (inters(p[a], p[b], p[i], p[j])) {
					pare2[i][j] = 0;
					pare2[j][i] = 0;
				}
			}
		}
		tre++;
	}
	if (tre % 2 == 0) {
		cout << 2 << endl;
	}
	else {
		cout << 1 << endl;
	}
	vector <vector <int>> pare(n, vector <int>(n, 1));
	if (tre % 2 == 0) {
		while (true) {
			int a, b;
			cin >> a >> b;
			if (a == 0) return 0;
			a--;
			b--;
			pare[a][b] = 0;
			pare[b][a] = 0;
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (i == j || i == a || i == b || j == a || j == b) continue;
					if (inters(p[a], p[b], p[i], p[j])) {
						pare[i][j] = 0;
						pare[j][i] = 0;
					}
				}
			}
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (i == j) continue;
					if (pare[i][j] == 1) {
						a = i; b = j;
					}
				}
			}
			pare[a][b] = 0;
			pare[b][a] = 0;
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (i == j || i == a || i == b || j == a || j == b) continue;
					if (inters(p[a], p[b], p[i], p[j])) {
						pare[i][j] = 0;
						pare[j][i] = 0;
					}
				}
			}

			cout << a + 1 << " " << b + 1 << endl;
		}
	}
	int a, b;
	cout << 1 << " " << 2 << endl;
	a = 0;
	b = 1;
	pare[0][1] = 0;
	pare[1][0] = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i == j || i == a || i == b || j == a || j == b) continue;
			if (inters(p[a], p[b], p[i], p[j])) {
				pare[i][j] = 0;
				pare[j][i] = 0;
			}
		}
	}
	while (true) {

		cin >> a >> b;
		if (a == 0) return 0;
		a--;
		b--;
		pare[a][b] = 0;
		pare[b][a] = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i == j || i == a || i == b || j == a || j == b) continue;
				if (inters(p[a], p[b], p[i], p[j])) {
					pare[i][j] = 0;
					pare[j][i] = 0;
				}
			}
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i == j) continue;
				if (pare[i][j] == 1) {
					a = i; b = j;
				}
			}
		}
		pare[a][b] = 0;
		pare[b][a] = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i == j || i == a || i == b || j == a || j == b) continue;
				if (inters(p[a], p[b], p[i], p[j])) {
					pare[i][j] = 0;
					pare[j][i] = 0;
				}
			}
		}

		cout << a + 1 << " " << b + 1 << endl;
	}
}