#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

const int N = 5e5 + 7;

int k;

int add(int a, int b) {
    if (a + b < k) {
        return a + b;
    }
    return a + b - k;
}

int sub(int a, int b) {
    if (a >= b) {
        return a - b;
    }
    return a - b + k;
}

int used[N];
vector<int> g[N];

int n;
vector<int> c;

set<pair<int, int>> cnt;
vector<int> wr;
vector<vector<int>> comps;

vector<int> seen;

bool ok(int x, int y) {
    return add(x, 1) == y || add(y, 1) == x;
}

void dfs(int cur) {
    used[cur] = 1;
    seen.push_back(cur);
    for (auto t : g[cur]) {
        if (!used[t] && ok(c[cur], c[t])) {
            dfs(t);
        }
    }
}

void merge(int u, int v) {
    if (comps[u].size() < comps[v].size()) swap(u, v);
    cnt.erase({comps[u].size(), u});
    cnt.erase({comps[v].size(), v});
    for (auto x : comps[v]) {
        wr[x] = u;
        comps[u].push_back(x);
    }
    cnt.insert({comps[u].size(), u});
    comps[v].clear();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int m;
    cin >> n >> m >> k;
    c.resize(n);
    wr.resize(n);
    for (auto &t : c) {
        cin >> t;
        t--;
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int pnt = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            comps.push_back(vector<int> ());
            int cur = pnt;
            seen.clear();
            dfs(i);
            for (auto t : seen) {
                wr[t] = cur;
                comps[cur].push_back(t);
            }
            cnt.insert({comps[cur].size(), cur});
            pnt++;
        }
    }
    while (cnt.size() > 1) {
        int w_sz = (int)cnt.size();
        int pr = cnt.begin()->second;
        int A = k;
        for (auto v : comps[pr]) {
            for (auto u : g[v]) {
                if (wr[u] != wr[v]) {
                    A = min(A, sub(add(c[v], 1), c[u]));
                    A = min(A, sub(sub(c[v], 1), c[u]));
                }
            }
        }
        for (auto v : comps[pr]) {
            c[v] += A;
            c[v] %= k;
        }
        vector<int> real_comp = comps[pr];
        for (auto v : real_comp) {
            for (auto u : g[v]) {
                if (wr[u] != wr[v]) {
                    assert(c[v] != c[u]);
                }
                if (wr[u] != wr[v] && ok(c[v], c[u])) {
                    merge(wr[u], wr[v]);
                }
            }
        }
        assert((int)cnt.size() < w_sz);
    }
    for (auto t : c) {
        cout << t + 1 << ' ';
    }
    cout << '\n';
}
