#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <cstring>
#include <iomanip>
#include <functional>



using namespace std;

// #define int long long     // <--- probably needed

const double eps = 1e-7;

struct point
{
	int x, y;
	point() {}
	point( int _x, int _y ) {
		x = _x;
		y = _y;
	}
};

point operator+( const point &a, const point &b ) {
	return point( a.x + b.x, a.y + b.y );
}

point operator-( const point &a, const point &b ) {
	return point( a.x - b.x, a.y - b.y );
}

int operator*( const point &a, const point &b ) { // cross product
	return a.x * b.y - a.y * b.x;
}

int operator%( const point &a, const point &b ) {
	return a.x * b.x + a.y * b.y;
}

bool operator==(const point &a, const point &b) {
	return a.x == b.x && a.y == b.y;
}


bool sign(int x) {
	if (x > 0) return 1;
	if (x < 0) return -1;
	return 0;
}


bool intersect(point a, point b, point c, point d) {
    if (a == c && b == d) return true;
	if (a == c || a == d || b == c || b == d) return false;
	if (sign( (d - a) * (b - a) ) != sign( (c - a) * (b - a) )) {
		if (sign( (a - c) * (d - c) ) != sign( (b - c) * (d - c) )) {
			return true;
		}
	}
	return false;
}


signed main() {
	int n;
	cin >> n;
	vector<point> a(n);
	for (int i = 0; i < n; i++) cin >> a[i].x >> a[i].y;

	vector<pair<point, point> > s;
	for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            int t = 1;
            for (auto e : s) if (intersect(e.first, e.second, a[i], a[j])) t = 0;
            if (t)
            {
                s.push_back({a[i], a[j]});
            }
        }
    }
    int fl = 2;
    if (s.size() % 2 == 1) fl = 1;

    cout << fl << endl;
    s.clear();

    int mi = 0, mj = 1;

    while (1)
    {
        if (fl == 2)
        {
            int i, j;
            cin >> i >> j;
            if (i == j && i == 0) return 0;
            if (i > j) swap(i, j);
            i--, j--;
            s.push_back({a[i], a[j]});
            fl = 1;
        }
        else
        {
            int gg = 0;
            for (; !gg && mi < n; mi++, mj = mi + 1)
            {
                for (; !gg && mj < n; mj++)
                {
                    int t = 1;
                    for (auto e : s) if (intersect(e.first, e.second, a[mi], a[mj])) t = 0;
                    if (t)
                    {
                        s.push_back({a[mi], a[mj]});
                        gg = 1;
                        cout << mi + 1 << " " << mj + 1 << endl;
                    }
                }
            }
            fl = 2;
        }
    }

	return 0;
}
