﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <queue>
#include <cassert>
#include<assert.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define mp make_pair
#define pb push_back
#define ft first
#define sd second
;

inline bool is_capital(char c) {
	return c >= 'A' && c <= 'Z';
}

vector<vector<int>> gr;
vector<bool> used;
vector<bool> is_taken;
vector<vector<int>> sofa;
vector<pair<int, int>> dir = { {0, 1}, {0, -1}, {1, 0}, {-1, 0} };
vector<vector<bool>> uss;


void dfs(int v, int color = 1) {
	used[v] = true;
	is_taken[v] = color;
	for (int u : gr[v])
		if (!used[u])
			dfs(u, color ^ 1);
		else if (is_taken[u])
			is_taken[v] = false;
}

int n, m;

bool check(int x, int y) {
	return x >= 0 && x < n&& y >= 0 && y < m;
}

vector<int> vals(int x, int y) {
	vector<int> ans;
	if (check(x - 1, y))
		ans.push_back(sofa[x - 1][y]);
	if (check(x - 1, y + 1))
		ans.push_back(sofa[x - 1][y + 1]);
	if (check(x, y - 1))
		ans.push_back(sofa[x][y - 1]);
	if (check(x, y + 2))
		ans.push_back(sofa[x][y + 2]);
	if (check(x + 1, y - 1))
		ans.push_back(sofa[x + 1][y - 1]);
	if (check(x + 1, y + 2))
		ans.push_back(sofa[x + 1][y + 2]);
	if (check(x + 2, y))
		ans.push_back(sofa[x + 2][y]);
	if (check(x + 2, y + 1))
		ans.push_back(sofa[x + 2][y + 1]);
	return ans;
}

vector<int> vals_hor(int x, int y) {
	vector<int> ans;
	if (check(x - 1, y))
		ans.push_back(sofa[x - 1][y]);
	if (check(x - 1, y + 1))
		ans.push_back(sofa[x - 1][y + 1]);
	if (check(x, y - 1))
		ans.push_back(sofa[x][y - 1]);
	if (check(x, y + 2))
		ans.push_back(sofa[x][y + 2]);
	if (check(x + 1, y))
		ans.push_back(sofa[x + 1][y]);
	if (check(x + 1, y + 1))
		ans.push_back(sofa[x + 1][y + 1]);
	return ans;
}

vector<int> vals_ver(int x, int y) {
	vector<int> ans;
	if (check(x - 1, y))
		ans.push_back(sofa[x - 1][y]);
	if (check(x , y - 1))
		ans.push_back(sofa[x][y - 1]);
	if (check(x, y + 1))
		ans.push_back(sofa[x][y + 1]);
	if (check(x + 1, y - 1))
		ans.push_back(sofa[x + 1][y - 1]);
	if (check(x + 1, y + 1))
		ans.push_back(sofa[x + 1][y + 1]);
	if (check(x + 2, y))
		ans.push_back(sofa[x + 2][y]);
	return ans;
}

int process(vector<int> vals) {
	vector<bool> good(10, true);
	for (int val : vals)
		if (val >= 0 && val < 10)
			good[val] = false;
	for (int i = 0; i < 10; i++)
		if (good[i])
			return i;
}



inline void solve() {
	cin >> n >> m;
	vector<vector<char>> field(n, vector<char>(m));
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			cin >> field[i][j];
		}
	sofa.resize(n, vector<int>(m, -1));
	vector<vector<vector<int>>> sofa_result(n, vector<vector<int>>(m, vector<int>()));
	vector<bool> positive_direction;
	vector<bool> horizontal;
	vector<bool> possible;
	vector<int> x, y;
	int cur = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			if (i < n - 1 && field[i][j] != '.' && field[i + 1][j] == field[i][j]) {
				x.push_back(i);
				y.push_back(j);
				sofa[i][j] = sofa[i + 1][j] = cur++;
				positive_direction.push_back(is_capital(field[i][j]));
				horizontal.push_back(false);
				if (positive_direction.back())
					if (j == m - 1)
						possible.push_back(false);
					else if (field[i][j + 1] != '.' || field[i + 1][j + 1] != '.')
						possible.push_back(false);
					else {
						possible.push_back(true);
						sofa_result[i][j + 1].push_back(cur - 1);
						sofa_result[i + 1][j + 1].push_back(cur - 1);
					}
				else
					if (j == 0)
						possible.push_back(false);
					else if (field[i][j - 1] != '.' || field[i + 1][j - 1] != '.')
						possible.push_back(false);
					else {
						possible.push_back(true);
						sofa_result[i][j - 1].push_back(cur - 1);
						sofa_result[i + 1][j - 1].push_back(cur - 1);
					}
			}
			if (j < m - 1 && field[i][j] != '.' && field[i][j + 1] == field[i][j]) {
				x.push_back(i);
				y.push_back(j);
				sofa[i][j] = sofa[i][j + 1] = cur++;
				positive_direction.push_back(is_capital(field[i][j]));
				horizontal.push_back(true);
				if (positive_direction.back())
					if (i == n - 1)
						possible.push_back(false);
					else if (field[i + 1][j] != '.' || field[i + 1][j + 1] != '.')
						possible.push_back(false);
					else {
						possible.push_back(true);
						sofa_result[i + 1][j].push_back(cur - 1);
						sofa_result[i + 1][j + 1].push_back(cur - 1);
					}
				else
					if (i == 0)
						possible.push_back(false);
					else if (field[i - 1][j] != '.' || field[i - 1][j + 1] != '.')
						possible.push_back(false);
					else {
						possible.push_back(true);
						sofa_result[i - 1][j].push_back(cur - 1);
						sofa_result[i - 1][j + 1].push_back(cur - 1);
					}
			}
		}
	gr.resize(cur);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			for (int u = 0; u < sofa_result[i][j].size(); u++)
				for (int uu = u + 1; uu < sofa_result[i][j].size(); uu++)
					if (possible[sofa_result[i][j][u]] && possible[sofa_result[i][j][uu]]) {
						gr[sofa_result[i][j][u]].push_back(sofa_result[i][j][uu]);
						gr[sofa_result[i][j][uu]].push_back(sofa_result[i][j][u]);
					}
	is_taken.resize(cur);
	used.resize(cur);
	for (int i = 0; i < cur; i++) {
		if (!possible[i]) {
			used[i] = true;
		}
		if (gr[i].size() == 1 && !used[i])
			dfs(i);
	}
	for (int i = 0; i < cur; i++)
		if (!used[i])
			dfs(i);

	int ans = 0;
	for (int i = 0; i < cur; i++) {
		if (is_taken[i]) {
			ans++;
			int x_ = x[i];
			int y_ = y[i];
			if (horizontal[i])
				if (positive_direction[i])
					sofa[x_][y_] = sofa[x_ + 1][y_ + 1] = sofa[x_ + 1][y_] = sofa[x_][y_ + 1] = i;
				else
					sofa[x_][y_] = sofa[x_][y_ + 1] = sofa[x_ - 1][y_] = sofa[x_ - 1][y_ + 1] = i;
			else
				if (positive_direction[i]) 
					sofa[x_][y_] = sofa[x_ + 1][y_ + 1] = sofa[x_ + 1][y_] = sofa[x_][y_ + 1] = i;
				else
					sofa[x_][y_] = sofa[x_ + 1][y_] = sofa[x_][y_ - 1] = sofa[x_ + 1][y_ - 1] = i;
		}
		else {
			int x_ = x[i];
			int y_ = y[i];
			if (horizontal[i])
				sofa[x_][y_] = sofa[x_][y_ + 1] = i;
			else
				sofa[x_][y_] = sofa[x_ + 1][y_] = i;
		}
	}
	for (int i = 0; i < cur; i++) {
		int x_ = x[i];
		int y_ = y[i];
		if (is_taken[i])
			if (horizontal[i])
				if (positive_direction[i])
					sofa[x_][y_] = sofa[x_ + 1][y_ + 1] = sofa[x_ + 1][y_] = sofa[x_][y_ + 1] = process(vals(x_, y_));

				else
					sofa[x_][y_] = sofa[x_][y_ + 1] = sofa[x_ - 1][y_] = sofa[x_ - 1][y_ + 1] = process(vals(x_ - 1, y_));

			else
				if (positive_direction[i])
					sofa[x_][y_] = sofa[x_ + 1][y_ + 1] = sofa[x_ + 1][y_] = sofa[x_][y_ + 1] = process(vals(x_, y_));
				else
					sofa[x_][y_] = sofa[x_ + 1][y_] = sofa[x_][y_ - 1] = sofa[x_ + 1][y_ - 1] = process(vals(x_, y_ - 1));
		else
			if (horizontal[i])
				sofa[x_][y_] = sofa[x_][y_ + 1] = process(vals_hor(x_, y_));
			else
				sofa[x_][y_] = sofa[x_ + 1][y_] = process(vals_ver(x_, y_));

	}
	cout << ans << '\n';
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++)
			if (sofa[i][j] == -1)
				cout << '.';
			else
				cout << sofa[i][j];
		cout << '\n';
	}
}

int32_t main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	solve();
}