﻿#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <set>
#include <algorithm>
#include <cassert>
#include <map>
#include <queue>
#include <bitset>
#include <iomanip>
#include <unordered_set>
#include <ctime>
#include <cassert>
#include <string>
#pragma GCC optimize("Ofast")
#define X first
#define Y second
#define pii pair<int, int>
#define vi vector<int>
#define vvi vector<vi>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using namespace std;
const int N = 1e6, alp = 26, Log = 17;
const double pi = abs(acos(-1)), eps = 1e-6, eps2 = 1e-9, inf = 1e30;
int mod = 1e9 + 7, mod2 = 1791791791;

const double EPS = 1E-9;
struct pt {
	double x, y;
	bool operator< (const pt& p) const {
		return x < p.x - EPS || abs(x - p.x) < EPS && y < p.y - EPS;
	}
};
struct line {
	double a, b, c;
	line() {}
	line(pt p, pt q) {
		a = p.y - q.y;
		b = q.x - p.x;
		c = -a * p.x - b * p.y;
		norm();
	}
	void norm() {
		double z = sqrt(a * a + b * b);
		if (abs(z) > EPS)
			a /= z, b /= z, c /= z;
	}
	double dist(pt p) const {
		return a * p.x + b * p.y + c;
	}
};
bool operator==(pt a, pt b) {
	return abs(a.x - b.x) < EPS && abs(a.y - b.y) < EPS;
}
#define det(a,b,c,d) (a*d-b*c)
inline bool betw(double l, double r, double x) {
	return min(l, r) <= x + EPS && x <= max(l, r) + EPS;
}
bool intersect(pt a, pt b, pt c, pt d, pt& left, pt& right) {
	if (a == c || a == d || b == c || b == d)
		return 0;
	line m(a, b);
	line n(c, d);
	return betw(a.x, b.x, left.x)
		&& betw(a.y, b.y, left.y)
		&& betw(c.x, d.x, left.x)
		&& betw(c.y, d.y, left.y);
}

struct klunok {
	vector<pair<pt, pt>> a;

	bool add(pair<pt, pt> l) {
		pt pizda;
		for (auto x : a)
			if (intersect(x.X, x.Y, l.X, l.Y, pizda, pizda))
				return false;
		a.push_back(l);
		return true;
	}
};

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL); cout.tie(NULL);
	int n;
	cin >> n;
	vector<pt> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i].x >> a[i].y;
	klunok dima;
	for (int i = 0; i < n; ++i)
		for (int j = i + 1; j < n; ++j)
			dima.add({ a[j], a[i] });
	int y;
	if (dima.a.size() & 1)
		cout << (y = 1) << endl;
	else
		cout << (y = 2) << endl;
	dima.a.clear();
	vi b(n * n, 0);
	if (y == 1) {
		cout << "1 2" << endl;
		dima.add({ a[0], a[1] });
		b[0 * n + 1] = 1;
		b[1 * n + 0] = 1;
	}
	for (int i = 0; i < n; ++i)
		b[i * n + i] = 1;
	int curr = 0;
	while (true) {
		int u, v;
		cin >> u >> v;
		if (!u)
			break;
		--u;
		--v;
		dima.add({ a[u], a[v] });
		b[u * n + v] = 1;
		b[v * n + u] = 1;
		while (b[curr] || !dima.add({a[curr / n], a[curr % n]}))
			++curr;
		cout << curr / n + 1 << " " << curr % n + 1 << endl;
		b[curr] = 1;
		b[(curr % n) * n + curr / n] = 1;
	}
}