//#define MANSON
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <random>
#include <chrono>
#include <string>
#include <set>
using namespace std;
#ifdef MANSON
#define BUGO(x) cerr << #x << " = " << (x) << '\n';
#define BUGOARR(a) cerr << #a << ": "; for (auto i: a) cerr << i << ' '; cerr << '\n';
ostream& operator<<(ostream& out, const pair<auto, auto>& p) {
    return out << "{" << p.first << ", " << p.second << "}";
}
#else
#define BUGO(x)
#define BUGOARR(a)
#endif
using llong = long long;
using uint = unsigned int;
using ullong = unsigned long long;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline int rnd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }

int MaxLen(const string& a)
{
    int ans = 0;
    for (int i = 0; i < a.size(); ++i)
    {
        int j = i;
        while (j + 1 < a.size() && a[i] == a[j + 1]) ++j;
        ans = max(ans, j - i + 1);
        i = j;
    }
    return ans;
}
pair<int, llong> Solve(llong ia, llong ib)
{
    string a = to_string(ia);
    string b = to_string(ib);
    int ans = 0;
    for (char i = '1'; i <= '9'; ++i) {
        llong cur = stoll(string(b.size(), i));
        if (ia <= cur && cur <= ib)
            ++ans;
    }
    if (ans)
        return make_pair(b.size(), ans);
    else
    {
        int ans = 0;
        set<llong> s;
        for (char i = '1'; i <= '9'; ++i)
            for (char j = '0'; j <= '9'; ++j)
            {
                string c = string(1, i) + string(b.size() - 1, j);
                llong cll = stoll(c);
                if (ia <= cll && cll <= ib)
                    s.insert(cll);
                c = string(b.size() - 1, i) + string(1, j);
                cll = stoll(c);
                if (ia <= cll && cll <= ib)
                    s.insert(cll);
            }
        return make_pair(b.size() - 1, s.size());
    }
}
int main()
{
    llong pw[19];
    pw[0] = 1;
    for (int i = 1; i <= 18; ++i)
        pw[i] = pw[i - 1] * 10LL;
#define Pow10(x) pw[(x)]
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        llong ia, ib;
        cin >> ia >> ib;
        string a = to_string(ia), b = to_string(ib);
        if (a.size() < b.size() || a[0] != b[0])
        {
            auto p = Solve(ia, ib);
            cout << p.first << ' '<< p.second << '\n';
            continue;
        }
        string comm;
        {
            int i = 0;
            while (i < b.size() && a[i] == b[i]) comm += b[i++];
        }
        int n = b.size();
        int clen = MaxLen(comm);
        string tailed = comm;
        while (tailed.size() && tailed.back() == comm.back()) tailed.pop_back();
        int tail = 0;
        while (tailed.size() < n)
        {
            tailed.push_back(comm.back());
            llong dll = stoll(tailed);
            if (dll < ia / Pow10(n - tailed.size()) || dll > ib / Pow10(n - tailed.size())) {
                tailed.pop_back();
                break;
            }
            ++tail;
        }
        static string ar, br;
        ar.clear(); br.clear();
        for (int i = comm.size(); i < n; ++i) {
            ar.push_back(a[i]);
            br.push_back(b[i]);
        }
        pair<int, llong> ansr = Solve(stoll(ar), stoll(br));
        llong tailans = Pow10(n - tailed.size());
        llong taill = stoll(tailed);
        if (tailed.size() == n)
            tailans = 1;
        else if (taill == ia / Pow10(n - tailed.size()))
            tailans -= ia % Pow10(n - tailed.size());
        else if (taill == ib / Pow10(n - tailed.size()))
            tailans = ib % Pow10(n - tailed.size()) + 1;
        if (clen >= tail && clen >= ansr.first)
            cout << clen << ' ' << ib - ia + 1 << '\n';
        else if (tail > ansr.first)
            cout << tail << ' ' << tailans << '\n';
        else if (ansr.first > tail)
            cout << ansr.first << ' ' << ansr.second << '\n';
        else
        {
            llong ans = tailans + ansr.second;
            for (char i = '0'; i <= '9'; ++i)
                if (n - tailed.size() == ansr.first)
                {
                    llong cur = stoll(tailed + string(n - tailed.size(), i));
                    if (ia <= cur && cur <= ib)
                        --ans;
                }
            cout << tail << ' ' << ans << '\n';
        }
    }
    return 0;
}
