#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()

using namespace std;

struct point {
    int x, y;

    point(int x1 = 0, int y1 = 0) {
        x = x1, y = y1;
    }

    point operator+ (point other) {
        return point{ x + other.x, y + other.y };
    }
    point operator-() {
        return point{ -x, -y };
    }
    point operator- (point other) {
        return point{ x - other.x, y - other.y };
    }
    int operator* (point other) { //scalar multiplication
        return x * other.x + y * other.y;
    }
    int operator^ (point other) { //vector multiplication
        return x * other.y - y * other.x;
    }
};

bool SegmentCrossing(point a1, point b1, point a2, point b2) {
    if (((a1 - b1) ^ (a1 - a2)) * ((a1 - b1) ^ (a1 - b2)) < 0 && ((a2 - b2) ^ (a2 - a1)) * ((a2 - b2) ^ (a2 - b1)) < 0) {
        return true;
    }
    return false;
}

int kol(vector<point> a) {
    vector<pair<int, int>> can;
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j)
            can.emplace_back(i, j);
    }
    int ans = 0;
    while (can.size()) {
        int f = can.back().first;
        int s = can.back().second;
        can.pop_back();
        ++ans;
        for (int i = 0; i < can.size(); ++i) {
            if (SegmentCrossing(a[can[i].first], a[can[i].second], a[f], a[s])) {
                swap(can[i], can.back());
                can.pop_back();
                --i;
            }
        }
    }
    return ans;
}

int main() {
    int n;
    cin >> n;
    vector<point> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i].x >> a[i].y;
    int who = (kol(a) % 2 == 0) ? 2 : 1;
    cout << who << '\n';
    vector<pair<int, int>> can;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j)
            can.emplace_back(i, j);
    }
    int type = who % 2;
    while (true) {
        if (type == 0) {
            int c, d;
            cin >> c >> d;
            if (c == 0 && d == 0)
                return 0;
            for (int i = 0; i < can.size(); ++i) {
                if (SegmentCrossing(a[can[i].first], a[can[i].second], a[c - 1], a[d - 1])) {
                    swap(can[i], can.back());
                    can.pop_back();
                    --i;
                }
            }
        }
        else {
            int f = can.back().first;
            int s = can.back().second;
            can.pop_back();
            cout << f + 1 << ' ' << s + 1 << '\n';
            for (int i = 0; i < can.size(); ++i) {
                if (SegmentCrossing(a[can[i].first], a[can[i].second], a[f], a[s])) {
                    swap(can[i], can.back());
                    can.pop_back();
                    --i;
                }
            }
        }
        type ^= 1;
    }
}