#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pi = pair<int, int>;

template <class T> bool ckmin(T &a,T b){ return a > b? a=b, true : false;}
template <class T> bool ckmax(T &a,T b){ return a < b? a=b, true : false;}

#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define mt make_tuple
#define F first
#define S second

// const int N = 2e5 + 500;
const int mod = 1e9 + 7; //998244353
const int INF = INT_MAX >> 1;
const ll LINF = LLONG_MAX >> 1;
const ld eps = 1e-9;

struct Sofa {
    int i, j, d, opened;
};

vector<pi> mov[4] = {
    { {0, 1}, {1, 1} },    // | ->
    { {0, -1}, {1, -1} },  // <- | 
    { {1, 0}, {1, 1} },    // -- DOWN
    { {-1, 0}, {-1, 1} }   // -- UP
};

const int M = 1e6;

int n, m, col[M], res[1000][1000], out[1000][1000], ans;
bool used[1000][1000];
char s[1000][1001];
vector<Sofa> sofas;
vi g[M];

bool okay(int i, int j) {
    return i >= 0 && i < n && j >= 0 && j < m && s[i][j] == '.';
}

bool okay_k(int i, int j) {
    return i >= 0 && i < n && j >= 0 && j < m;
}

bool dfs(int v, int p, vi& a, vi& b) {
    if (col[v] == 1) a.push_back(v);
    if (col[v] == 2) b.push_back(v);

    for (int to : g[v]) {
        if (to == p) continue;
        if (col[to]) {
            return true;
        } else {
            col[to] = col[v] ^ 3;
            if (dfs(to, v, a, b)) return true;
        }
    }

    return false;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    //freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
    cin >> n >> m;
    for (int i = 0; i < n; ++i) cin >> s[i];
    for (int i = 0; i < n; ++i) 
    for (int j = 0; j < m; ++j) {
        if (used[i][j]) continue;

        if ('a' <= s[i][j] && s[i][j] <= 'z') {
            if (i < n && s[i+1][j] == s[i][j]) {
                sofas.push_back({i, j, 1, 0});
                used[i+1][j] = true;
            }
            if (j < m && s[i][j+1] == s[i][j]) {
                sofas.push_back({i, j, 3, 0});
                used[i][j+1] = true;
            }
        }
        if ('A' <= s[i][j] && s[i][j] <= 'Z') {
            if (i < n && s[i+1][j] == s[i][j]) {
                sofas.push_back({i, j, 0, 0});
                used[i+1][j] = true;
            }
            if (j < m && s[i][j+1] == s[i][j]) {
                sofas.push_back({i, j, 2, 0});
                used[i][j+1] = true;
            }
        }
        used[i][j] = true;
    }

    map<pi, int> bad_sofa;
    for (int t = 0; t < sofas.size(); ++t) {
        bool ok = true;
        for (auto [di, dj] : mov[sofas[t].d]) {
            if (!okay(sofas[t].i + di, sofas[t].j + dj)) ok = false;
        }

        // cout << "Sofa #" << t << " -> " << sofas[t].i << " " << sofas[t].j << " " << sofas[t].d << endl;

        if (!ok) continue;
        for (auto [di, dj] : mov[sofas[t].d]) {
            const int ni = sofas[t].i + di, nj = sofas[t].j + dj;
            if (okay(ni, nj)) {
                // cout << "* see " << ni << " " << nj << endl;
                if (bad_sofa.count({ni, nj})) {
                    const int p = bad_sofa[{ni, nj}];
                    g[t].push_back(p);
                    g[p].push_back(t);
                    // cout << "Add edge " << p << " " << t << endl;
                } else {
                    bad_sofa[{ni, nj}] = t;
                }
            }
        }
    }

    for (int i = 0; i < sofas.size(); ++i) {
        bool ok = true;
        for (auto [di, dj] : mov[sofas[i].d]) {
            if (!okay(sofas[i].i + di, sofas[i].j + dj)) ok = false;
        }
        if (col[i] || !ok) continue;

        col[i] = 1;
        vi a, b;
        bool cycle = dfs(i, -1, a, b);
        // cout << (cycle ? "Cycle" : "Line") << " => " << i << endl;
        if (cycle) {
            if (a.size() > b.size()) a.swap(b);
        } else {
            if (a.size() < b.size()) a.swap(b);
        }

        for (int i : a) sofas[i].opened = 1;
        ans += a.size();
    }

    cout << ans << endl;
    for (int t = 0; t < sofas.size(); ++t) {
        int ai = sofas[t].i, aj = sofas[t].j;
        int bi = sofas[t].i, bj = sofas[t].j;
        if (sofas[t].opened) {
            for (auto [di, dj] : mov[sofas[t].d]) {
                int ni = sofas[t].i + di, nj = sofas[t].j + dj;
                ckmin(ai, ni), ckmin(aj, nj);
                ckmax(bi, ni), ckmax(bj, nj);
            }
        } else {
            if (sofas[t].d == 0 || sofas[t].d == 1) ++bi;
            if (sofas[t].d == 2 || sofas[t].d == 3) ++bj;
        }

        for (int i = ai; i <= bi; ++i)
        for (int j = aj; j <= bj; ++j) 
            res[i][j] = t+1;
    }

    for (int i = 0; i < n; ++i)
    for (int j = 0; j < m; ++j)
        used[i][j] = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!res[i][j] || used[i][j]) continue;

            set<int> s { 0 };
            if (okay_k(i-1, j))   s.insert(out[i-1][j]);
            if (okay_k(i-1, j+1)) s.insert(out[i-1][j+1]);
            if (okay_k(i, j-1))   s.insert(out[i][j-1]);
            if (okay_k(i+1, j-1)) s.insert(out[i+1][j-1]);
            if (okay_k(i, j+1))   s.insert(out[i][j+1]);
            if (okay_k(i, j+2))   s.insert(out[i][j+2]);
            
            int k = 1;
            while (s.count(k)) ++k;
            for (int di = 0; di < 2; ++di)
            for (int dj = 0; dj < 2; ++dj) {
                if (!okay_k(i+di, j+dj)) continue;
                if (res[i][j] == res[i+di][j+dj])
                    out[i+di][j+dj] = k, used[i+di][j+dj] = 1;
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        string s;
        for (int j = 0; j < m; ++j) {
            s.push_back(out[i][j] ? '0' + out[i][j] : '.');
        }
        cout << s << '\n';
    }

    return 0;
}